Debian ISOs do not contain signed Release files
[grml-debootstrap.git] / grml-debootstrap
index dbf9759..3085637 100755 (executable)
@@ -1,19 +1,44 @@
-#!/bin/sh
-# Filename:      grml-bootstrap
-# Purpose:       wrapper around debootstrap for installing plain Debian via grml
+#!/bin/bash
+# Filename:      grml-debootstrap
+# Purpose:       wrapper around debootstrap for installing plain Debian via Grml
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
-# License:       This file is licensed under the GPL v2.
+# License:       This file is licensed under the GPL v2+
 ################################################################################
 # http://www.debian.org/releases/stable/i386/index.html.en
 
-set -e # exit on any error
-
 # variables {{{
 PN="$(basename $0)"
-VERSION='0.30'
+VERSION="$(dpkg --list $PN 2>/dev/null| awk '/^i/ {print $3}')"
+VERSION="${VERSION:-unknown}"
 MNTPOINT="/mnt/debootstrap.$$"
 
+# defaults
+CHROOT_SCRIPTS='yes'
+CONFFILES='/etc/debootstrap'
+DEBCONF='yes'
+DEBIAN_FRONTEND='noninteractive'
+DEBOOTSTRAP='debootstrap'
+EXTRAPACKAGES='yes'
+FORCE=''
+HOSTNAME='grml'
+INITRD='yes'
+INSTALL_NOTES='/etc/debootstrap/install_notes'
+LOCALES='yes'
+MIRROR='http://cdn.debian.net/debian'
+MKFS='mkfs.ext3'
+PACKAGES='yes'
+PRE_SCRIPTS='yes'
+RECONFIGURE='console-data'
+RELEASE='squeeze'
+RM_APTCACHE='yes'
+SCRIPTS='yes'
+SECURE='yes'
+TIMEZONE='Europe/Vienna'
+TUNE2FS='tune2fs -c0 -i0'
+UPGRADE_SYSTEM='yes'
+VMSIZE="2G"
+
 # inside the chroot system locales might not be available, so use minimum:
 export LANG=C
 export LC_ALL=C
@@ -23,11 +48,6 @@ export LC_ALL=C
 INTERACTIVE=''
 # }}}
 
-# source core functions {{{
-. /etc/grml/lsb-functions
-. /etc/grml/script-functions
-# }}}
-
 # help text {{{
 usage() {
   echo "$PN - wrapper around debootstrap for installing Debian
@@ -38,8 +58,8 @@ Bootstrap options:
 
   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
-                           instead of fetching packages from a mirror.
-  -r, --release <name>   Release of new Debian system (default: lenny).
+                         instead of fetching packages from a mirror.
+  -r, --release <name>   Release of new Debian system (default: squeeze).
   -t, --target <target>  Target partition (/dev/...) or directory where the
                          system should be installed to.
   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
@@ -47,11 +67,19 @@ Bootstrap options:
       --debopt <params>  Extra parameters passed to the debootstrap command.
       --interactive      Use interactive mode (frontend).
       --nodebootstrap    Skip debootstrap, only do configuration to the target.
-      --groot <device>   Root device for usage in grub, corresponds with
-                           \$TARGET in grub syntax, like hd0,0 for /dev/sda1.
-      --grub <device>    Target for grub installation. Use grub syntax for
-                           specifying, like hd0 for /dev/sda.
-      --arch <arch>      Architecture to use. Currently only i386 is supported.
+      --grub <device>    Target for grub installation. Usage example: /dev/sda
+      --arch <arch>      Set target architecture, use for installing i386 on amd64.
+      --filesystem <fs>  Filesystem that should be used when target is a partition
+                         or Virtual Machine (see --vmfile).
+      --force            Do not prompt for user acknowledgement.
+
+Options for Virtual Machine deployment:
+
+      --vmfile           Set up a Virtual Machine instead of installing to
+                         a partition or directory, to be combined with --target,
+                         like: --vmfile --target /mnt/sda1/qemu.img
+      --vmsize <size>    Use specified size for size of VM file (default: 2G).
+                         Syntax as supported by qemu-img, like: --vmsize 3G
 
 Configuration options:
 
@@ -59,14 +87,20 @@ Configuration options:
                              /etc/debootstrap/config
   -d, --confdir <path>     Place of config files for debootstrap, defaults
                              to /etc/debootstrap
-      --packages <file>    Install packages defined in specified list file.
+      --packages <file>    Install packages defined in specified list file
+                             instead of using /etc/debootstrap/packages.
+      --nopackages         Skip installation of packages defined in
+                             /etc/debootstrap/packages
       --debconf <file>     Pre-seed packages using specified pre-seed db file.
+      --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
       --keep_src_list      Do not overwrite user provided apt sources.list.
       --hostname <name>    Hostname of Debian system.
+      --nopassword         Do not prompt for the root password.
       --password <pwd>     Use specified password as password for user root.
       --bootappend <line>  Add specified appendline to kernel whilst booting.
       --chroot-scripts <d> Execute chroot scripts from specified directory.
-      --scripts <dir>      Execute scripts from specified directory.
+      --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
+      --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
 
 Other options:
 
@@ -79,40 +113,175 @@ Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
 "
 }
 
-if [ "$1" = '-h' ] || [ "$1" = '-help' ] ; then
+if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
    usage
    echo 'Please notice that this script requires root permissions!'
    exit 0
 fi
 # }}}
 
+# early helper functions {{{
+GOOD='\e[32;01m'
+WARN='\e[33;01m'
+BAD='\e[31;01m'
+NORMAL='\e[0m'
+HILITE='\e[36;01m'
+BRACKET='\e[34;01m'
+
+einfo() {
+  einfon "$1\n"
+  return 0
+}
+
+einfon() {
+  [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
+  printf " ${GOOD}*${NORMAL} $*"
+  LAST_E_CMD=einfon
+  return 0
+}
+
+eerror() {
+  [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
+  printf " ${BAD}*${NORMAL} $*\n" >&2
+  LAST_E_CMD=eerror
+  return 0
+}
+
+eend() {
+  local retval="${1:-0}"
+  shift
+  if [ $retval -gt 0 ]; then
+    printf " ${BAD}-> Failed (rc=${retval})${NORMAL}\n"
+  fi
+  return $retval
+}
+
+check4root(){
+  if [ "$(id -u 2>/dev/null)" != 0 ] ; then
+    echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
+  fi
+}
+
+check4progs(){
+  local RC=''
+  for arg in $* ; do
+    which $arg >/dev/null 2>&1 || RC="$arg"
+  done
+  if [ -n "$RC" ] ; then
+     echo "$RC not installed"
+     return 1
+  fi
+}
+# }}}
+
+# helper functions {{{
+cleanup() {
+  if [ -n "$CHROOT_VARIABLES" ] ; then
+    einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+  fi
+
+  if [ -n "$STAGES" ] ; then
+    einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
+  fi
+
+  # Remove temporary mountpoint again
+  if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+    rmdir "$MNTPOINT" 2>/dev/null
+  fi
+
+  # make sure $TARGET is not mounted when exiting grml-debootstrap
+  if [ -n "$MNTPOINT" ] ; then
+    if grep -q "$MNTPOINT" /proc/mounts ; then
+      # make sure nothing is left inside chroot so we can unmount it
+      [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
+      [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
+
+      [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
+
+      # ugly, but make sure we really don't leave anything (/proc /proc and
+      # /dev /dev are intended, trying to work around timing issues, see #657023)
+      for ARG in /sys /proc /proc /dev /dev ; do
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
+        umount "$MNTPOINT"/$ARG >/dev/null 2>&1
+      done
+
+      if [ -n "$ISODIR" ] ; then
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
+      fi
+
+      if [ -n "$DIRECTORY" ] ; then
+        einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
+      else
+        einfo "Unmounting $MNTPOINT"
+        umount "$MNTPOINT"
+        eend $?
+      fi
+
+      if [ -n "$STAGES" ] ; then
+        echo -n "Removing stages directory ${STAGES}: "
+        rm -rf "$STAGES" && echo done
+      fi
+
+      # remove directory only if we used the default with process id inside the name
+      if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+        einfo "Removing directory ${MNTPOINT}"
+        rmdir "$MNTPOINT"
+        eend $?
+      fi
+    fi
+  fi
+
+  if [ -n "${ORIG_TARGET}" ] ; then
+    einfo "Removing loopback mount of file ${ORIG_TARGET}."
+    kpartx -d "${ORIG_TARGET}" ; eend $?
+  fi
+}
+
+# we want to exit smoothly and clean:
+bailout(){
+
+  cleanup
+
+  [ -n "$1" ] && EXIT="$1" || EXIT="1"
+  [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
+
+  exit "$EXIT"
+}
+trap bailout HUP INT QUIT TERM
+
+# we want to execute all the functions only once, simple check for it:
+stage() {
+  if [ -n "$2" ] ; then
+     echo "$2" > "${STAGES}/${1}"
+     return 0
+  elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
+     ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
+     ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
+     return 1
+  fi
+}
+# }}}
+
 # make sure we have what we need {{{
-check4progs debootstrap dialog || exit 1
-check4root || exit 1
+check4progs debootstrap || bailout 1
 # }}}
 
-# source configuration file {{{
+# source main configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
-   if [ -n "$CONFIGFILE" ] ; then
-      einfo "Using config file $CONFIGFILE."
-      if ! . "$CONFIGFILE" ; then
-         eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
-      fi
-   else
-      . /etc/debootstrap/config
-   fi
+  . /etc/debootstrap/config
 fi
 # }}}
 
 # cmdline handling {{{
 # source external command line parameter-processing script
-if [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
-   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
-elif [ -r ./cmdlineopts.clp ] ; then
+if [ -r ./cmdlineopts.clp ] ; then
    . ./cmdlineopts.clp
+elif [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
+   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
 else
-   echo "Error: cmdline function file not found, exiting.">&2
-   exit 1
+   eerror "Error: cmdline function file not found, exiting."
+   eend 1
+   bailout 1
 fi
 
 # == business-logic of command line parameter-processing
@@ -122,10 +291,10 @@ fi
   CONFFILES=$_opt_confdir
   einfo "Using config files under $CONFFILES/."
   if ! [ -r "$CONFFILES/config" ] ; then
-    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
   fi
   if ! . "$CONFFILES/config" ; then
-    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
   fi
   # restore the command line parameter value
   CONFFILES=$_opt_confdir
@@ -136,21 +305,29 @@ fi
 [ "$_opt_iso" ]                 && ISO=$_opt_iso
 [ "$_opt_release" ]             && RELEASE=$_opt_release
 [ "$_opt_target" ]              && TARGET=$_opt_target
+[ "$_opt_vmfile" ]              && VIRTUAL=1
+[ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
 [ "$_opt_interactive" ]         && INTERACTIVE=1
 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
+[ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
 [ "$_opt_packages_set" ]        && PACKAGES='yes'
+[ "$_opt_nopackages" ]          && PACKAGES=''
 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
 [ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
+[ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
+[ "$_opt_nopassword" ]          && NOPASSWORD='yes'
 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
-[ "$_opt_groot" ]               && GROOT=$_opt_groot
 [ "$_opt_grub" ]                && GRUB=$_opt_grub
 [ "$_opt_arch" ]                && ARCH=$_opt_arch
+[ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
+[ "$_opt_force" ]               && FORCE=$_opt_force
 [ "$_opt_verbose" ]             && VERBOSE="-v"
 
 [ "$_opt_help" ] && {
@@ -167,11 +344,50 @@ fi
 }
 # }}}
 
+# check for root permissions {{{
+if ! check4root ; then
+   echo "For usage instructions please execute '$PN --help'."
+   bailout 1
+fi
+# }}}
+
+# make sure we have what we need {{{
+if [ -n "$VIRTUAL" ] ; then
+  check4progs kpartx mksh parted qemu-img || bailout 1
+fi
+# }}}
+
+# source specified configuration file {{{
+if [ -n "$CONFIGFILE" ] ; then
+   einfo "Reading specified config file $CONFIGFILE."
+   if ! . "$CONFIGFILE" ; then
+      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
+   fi
+fi
+# }}}
+
+# backwards compability checks {{{
+if [ -n "$GROOT" ] ; then
+   eerror "Error: you seem to have \$GROOT configured."
+   eerror "This variable is no longer supported, please visit the"
+   eerror "grml-debootstrap documentation for details."
+   eend 1
+   bailout 1
+fi
+
+if echo "$GRUB" | grep -q '^hd' ; then
+   eerror "Error: this syntax for the grub configuration variable is no longer supported."
+   eerror "Please do not use hd... any longer but /dev/sdX instead."
+   eend 1
+   bailout 1
+fi
+# }}}
+
 # welcome screen {{{
 welcome_dialog()
 {
    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
-Do you want to continue installing Debian using this frontend?" 0 0
+Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
 }
 # }}}
 
@@ -188,16 +404,17 @@ prompt_for_target()
      --msgbox "Sorry, no partitions found. Please configure your
      harddisks (see /proc/partitions) using a tool like fdisk,
      cfdisk, gpart, gparted,..." 0 0
-     exit 0
+     bailout 1
   fi
 
   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                       echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
+                       echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet])"
                    done)
 
   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
          --menu "Please select the target partition:" 0 0 0 \
          $PARTITION_LIST)
+  [ $? -eq 0 ] || bailout 1
 }
 # }}}
 
@@ -222,7 +439,7 @@ prompt_for_bootmanager()
         MBRDISK=$(readlink -f $MBRDISK)
      else
         # fall back to old behaviour
-        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$/')
+        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$//')
      fi
 
      MBRPART="MBR of $MBRDISK"
@@ -241,7 +458,6 @@ prompt_for_bootmanager()
   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
             mbr       "install bootmanager into $MBRPART" \
-            partition "install bootmanager into partition $TARGET" \
             nowhere   "do not install bootmanager at all" \
           ${ADDITIONAL_PARAMS})
   [ $? -eq 0 ] || bailout 3
@@ -251,22 +467,24 @@ prompt_for_bootmanager()
     mbr)
       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
       if echo "$TARGET" | grep -q "/dev/md" ; then
-         BOOT_PARTITION="$TARGET"
+         # using sw-raid:
+         if [ -n "$SELECTED_PARTITIONS" ] ; then
+            GRUB=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
+         else
+            GRUB="$TARGET"
+         fi
       else
-         BOOT_PARTITION="$MBRDISK"
+        GRUB="$MBRDISK"
       fi
       ;;
-    partition)
-      BOOT_PARTITION="$TARGET"
-      ;;
     hda)
-      BOOT_PARTITION="/dev/hda"
+      GRUB="/dev/hda"
       ;;
     sda)
-      BOOT_PARTITION="/dev/sda"
+      GRUB="/dev/sda"
       ;;
     nowhere)
-      BOOT_PARTITION=''
+      GRUB=''
       ;;
   esac
 }
@@ -275,14 +493,15 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='lenny'
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='squeeze'
   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
             0 50 4 \
-            etch     Debian/old-stable \
-            lenny    Debian/stable \
-            squeeze  Debian/testing \
+            lenny    Debian/old-stable \
+            squeeze  Debian/stable \
+            wheezy   Debian/testing \
             sid      Debian/unstable)"
+  [ $? -eq 0 ] || bailout
 }
 # }}}
 
@@ -292,27 +511,35 @@ prompt_for_hostname()
   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
             "Please enter the hostname you would like to use for installation:" \
             0 0 $HOSTNAME)"
+  [ $? -eq 0 ] || bailout
 }
 # }}}
 
 # ask for password {{{
 prompt_for_password()
 {
-     ROOTPW1='PW1'
-     ROOTPW2='PW2'
-     while [ "$ROOTPW1" != "$ROOTPW2" ]; do
-       ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
-       "Please enter the password for the root account:" 10 60)
-       ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
-       "Please enter the password for the root account again for \
-       confirmation:" 10 60)
-
-       if [ "$ROOTPW1" != "$ROOTPW2" ]; then
-         $(dialog --stdout --title "${PN}" --ok-label \
-         "Retry" --msgbox "Passwords do not match!" 10 60)
-       fi
-     done
-     ROOTPASSWORD="$ROOTPW1"
+  if [ "$_opt_nopassword" ] ; then
+    einfo "Skip asking for root password as requested."
+    return 0
+  fi
+
+  ROOTPW1='PW1'
+  ROOTPW2='PW2'
+  while [ "$ROOTPW1" != "$ROOTPW2" ]; do
+    ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+    "Please enter the password for the root account:" 10 60)
+    [ $? -eq 0 ] || bailout
+    ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+    "Please enter the password for the root account again for \
+    confirmation:" 10 60)
+    [ $? -eq 0 ] || bailout
+
+    if [ "$ROOTPW1" != "$ROOTPW2" ]; then
+      $(dialog --stdout --title "${PN}" --ok-label \
+      "Retry" --msgbox "Passwords do not match!" 10 60)
+    fi
+  done
+  ROOTPASSWORD="$ROOTPW1"
 }
 # }}}
 
@@ -326,75 +553,24 @@ prompt_for_mirror()
             net   "install via network (downloading from mirror)" \
             local "install from local directory/mirror"
           )
+  [ $? -eq 0 ] || bailout
 
   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
      [ -n "$MIRROR" ] || MIRROR='http://cdn.debian.net/debian'
      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter Debian mirror you would like to use for installing packages." \
                0 0 $MIRROR)"
-  else # CHROOT_VARIABLES == local
+     [ $? -eq 0 ] || bailout
+  else # CHOOSE_MIRROR == local
      [ -n "$ISO" ] || ISO='/mnt/mirror'
      ISO="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter directory name you would like to use for installing packages." \
                0 0 $ISO)"
+     [ $? -eq 0 ] || bailout
   fi
 }
 # }}}
 
-# get grub's syntax for /dev/ice {{{
-# usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
-grubdevice() {
-  if [ -z "$1" ] ; then
-     echo "Usage: grubdevice <device>">&2
-     return 1
-  fi
-
-  device="$1"
-  device_map=$(mktemp)
-
-  # create device.map
-  if which grub >/dev/null 2>&1 ; then
-     echo 'quit' | grub --device-map="$device_map" >/dev/null 2>&1
-  elif which grub-mkdevicemap >/dev/null 2>&1 ; then
-     grub-mkdevicemap --device-map="$device_map" >/dev/null 2>&1
-  else
-    echo "Error: neither grub nor grub-mkdevicemap command found." >&2
-    return 1
-  fi
-
-  # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
-  tmp_disk=$(echo "$device" | sed -e 's%\(\(s\|h\|v\|xv\)d[a-z]\)[0-9]*$%\1%' \
-                    -e 's%\(fd[0-9]*\)$%\1%' \
-                    -e 's%/part[0-9]*$%/disc%' \
-                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%' \
-                    -e 's%\(mmcblk[0-9]d[0-9]*\).*$%\1%' \
-                    -e 's%\(/mapper/mpath[0-9]\+\)-part[0-9]\+$%\1%')
-  tmp_part=$(echo "$device" | sed -e 's%.*/\(s\|h\|v\|xv\)d[a-z]\([0-9]*\)$%\2%' \
-                    -e 's%.*/fd[0-9]*$%%' \
-                    -e 's%.*/floppy/[0-9]*$%%' \
-                    -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
-                    -e 's%.*c[0-7]d[0-9]*p*%%' \
-                    -e 's%.*mmcblk[0-9]d[0-9]*p%%' \
-                    -e 's%.*/mapper/mpath[0-9]\+-part\([0-9]\+\)%\1%')
-  tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
-
-  if [ -z "$tmp_drive" ]; then
-    echo "Error: $device does not have any corresponding BIOS drive." >&2
-    return 1
-  fi
-
-  case $1 in
-     /dev/[sh]d[a-z]) # we expect something like 'hd0'
-        echo "$tmp_drive"
-        ;;
-      *) # we expect something like 'hd0,0'
-        echo "$tmp_drive" | sed "s%$%,$(expr $tmp_part - 1)%" # FIXME => md0
-        ;;
-  esac
-  rm -f "$device_map"
-}
-# }}}
-
 # software raid setup {{{
 config_swraid_setup()
 {
@@ -427,12 +603,13 @@ AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
 [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
 PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                     echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
+                     echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet]) off"
                  done)
 
 dialog --title "$PN" --separate-output \
        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
        $PARTITION_LIST 2>$TMPFILE
+[ $? -eq 0 ] || bailout
 RETVAL=$?
 SELECTED_PARTITIONS="$(cat $TMPFILE)"
 
@@ -441,14 +618,16 @@ for i in $(cat $TMPFILE) ; do
    NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
 done
 
+# force metadata version 0.90 for lenny so old grub can boot from this array.
+METADATA_VERSION=""
+if [ $RELEASE = "lenny" ]; then
+   METADATA_VERSION="-e0"
+fi
+
 ERRORFILE=$(mktemp)
-set +e
-# TODO: better error handling?
 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
-      --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} 1>/dev/null 2>$ERRORFILE
+      --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
 RC=$?
-set -e
-
 if [ "$RC" = 0 ] ; then
    dialog --title "$PN" --msgbox \
    "Creating $TARGET was successful." 0 0
@@ -461,7 +640,7 @@ $(cat $ERRORFILE)
 
 Exiting." 0 0
    rm -f "$TMPFILE" "$ERRORFILE"
-   exit 1
+   bailout 1
 fi
 
 }
@@ -489,6 +668,7 @@ Last chance to quit. Timeout of 10 seconds running....
 
 Do you want to stop now?" 0 0 2>/dev/null
 }
+# }}}
 
 # make sure the user is aware of the used configuration {{{
 checkconfiguration()
@@ -496,7 +676,7 @@ checkconfiguration()
 if [ -n "$AUTOINSTALL" ] ; then
    if checkforrun ; then
       eerror "Exiting as requested" ; eend 0
-      exit 1
+      bailout 1
    fi
 elif [ -n "$INTERACTIVE" ] ; then
 
@@ -509,11 +689,13 @@ elif [ -n "$INTERACTIVE" ] ; then
    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
    Using release:   $RELEASE"
    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
-   Using hostname   $HOSTNAME"
+   Using hostname:  $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
    Using ISO:       $ISO"
+   [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
+   Using arch:      $ARCH"
 
    INFOTEXT="$INFOTEXT
 
@@ -521,29 +703,45 @@ Is this ok for you? Notice: selecting 'No' will exit ${PN}."
 
    dialog --title "$PN" --no-collapse \
           --yesno "$INFOTEXT" 0 0
+   [ $? -eq 0 ] || bailout 0
 
 else # if not running automatic installation display configuration and prompt for execution:
-   einfo "$PN - Please recheck configuration before execution:"
+   einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
    echo
    echo "   Target:          $TARGET"
 
    # do not display if MNTPOINT is the default one
    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
 
-   [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+   if [ -n "$VIRTUAL" ] ; then
+      echo "   Install grub:    yes"
+   else
+     [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+   fi
+
    [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
-   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
+   [ -n "$ARCH" ]     && echo "   Using arch:      $ARCH"
+   if [ -n "$VIRTUAL" ] ; then
+      echo "   Deploying as Virtual Machine."
+      [ -n "$VMSIZE" ] && echo "   Using Virtual Disk file with size of ${VMSIZE}."
+   fi
 
+   echo
    echo "   Important! Continuing will delete all data from ${TARGET}!"
 
-   echo
-   einfon "Is this ok for you? [y/N] "
-   read a
-   if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
-      eerror "Exiting as requested." ; eend 1
-      exit 1
+   if [ -n "$FORCE" ] ; then
+     einfo "Skip user acknowledgement as requested via --force option."
+   else
+     echo
+     einfon "Is this ok for you? [y/N] "
+     read a
+     if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
+        eerror "Exiting as requested." ; eend 1
+        bailout 1
+     fi
    fi
 fi
 }
@@ -552,34 +750,22 @@ fi
 # interactive mode {{{
 interactive_mode()
 {
+  check4progs dialog || bailout 1
+
   welcome_dialog
 
+  prompt_for_release
+
   prompt_for_swraid
 
   prompt_for_target
 
   prompt_for_bootmanager
 
-  prompt_for_release
-
   prompt_for_hostname
 
   prompt_for_password
 
-  # use first disk of sw-raid for grub by default, install grub on
-  # all involved disks later on
-  if echo "$TARGET" | grep -q '/dev/md' ; then
-     if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
-        # use hdX and not hdX,Y for $GRUB
-        TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
-        GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
-        GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
-     fi
-  else
-     [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
-     [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
-  fi
-
   prompt_for_mirror
 }
 
@@ -591,6 +777,17 @@ if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
 fi
 # }}}
 
+# architecture setup {{{
+if [ -n "$ARCH" ] ; then
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+else
+   ARCH="$(dpkg --print-architecture)"
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+fi
+# }}}
+
 checkconfiguration
 
 # finally make sure at least $TARGET is set [the partition for the new system] {{{
@@ -599,7 +796,7 @@ if [ -n "$TARGET" ] ; then
 else
    eerror "Please adjust $CONFFILES/config or..."
    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
-   exit 1
+   bailout 1
 fi
 # }}}
 
@@ -621,11 +818,7 @@ fi
 PARTITION=''
 DIRECTORY=''
 
-case $TARGET in
-  /dev/*)
-    PARTITION=1
-    ;;
-  *)
+set_target_directory(){
     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
     DIRECTORY=1
     MNTPOINT="$TARGET"
@@ -633,19 +826,16 @@ case $TARGET in
     TUNE2FS=''
     FSCK=''
     GRUB=''
-    GROOT=''
-    ;;
-esac
-# }}}
+    # make sure we normalise the path to an absolute directory name so something like:
+    #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
+    # works
+    TARGET="$(readlink -f $TARGET)"
+}
 
-# architecture setup {{{
-if [ -n "$ARCH" ] ; then
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
+if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
+    PARTITION=1
 else
-   ARCH="$(dpkg --print-architecture)"
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
+    set_target_directory
 fi
 # }}}
 
@@ -655,7 +845,7 @@ if [ -n "$ISO" ] ; then
       file*) # do nothing
       ;;
       *)
-      ISO=file:$1
+      ISO=file:$ISO
       ;;
    esac
 fi
@@ -663,60 +853,10 @@ ISODIR=${ISO##file:}
 ISODIR=${ISODIR%%/}
 # }}}
 
-# helper functions {{{
-# we want to exit smoothly and clean:
-bailout(){
-  # make sure $TARGET is not mounted when exiting grml-debootstrap
-  if [ -n "$MNTPOINT" ] ; then
-     if grep -q $MNTPOINT /proc/mounts ; then
-        # make sure nothing is left inside chroot so we can unmount it
-        [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
-        [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
-        # ugly, but make sure we really don't leav anything
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
-        [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
-
-        if [ -n "$DIRECTORY" ] ; then
-          einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
-        else
-          einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
-        fi
-
-        if [ -n "$STAGES" ] ; then
-           echo -n "Removing stages directory ${STAGES}: "
-           rm -rf "$STAGES" && echo done
-        fi
-
-        # remove directory only if we used the default with process id inside the name
-        if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-           einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
-        fi
-     fi
-  fi
-
-  [ -n "$1" ] && EXIT="$1" || EXIT="1"
-  [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
-
-  exit "$EXIT"
-}
-trap bailout HUP INT QUIT TERM
-
-# we want to execute all the functions only once, simple check for it:
-stage() {
-  if [ -n "$2" ] ; then
-     echo "$2" > "${STAGES}/${1}"
-     return 0
-  elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
-     ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
-     eindent
-       ewarn "To reexecute it clean up the according directory inside $STAGES" ; eend 0
-     eoutdent
-     return 1
-  fi
-}
+# Debian ISOs do not contain signed Release files {{{
+if [ -n "$ISO" ] ; then
+    DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
+fi
 # }}}
 
 # create filesystem {{{
@@ -726,14 +866,28 @@ mkfs() {
   else
     if grep -q "$TARGET" /proc/mounts ; then
       eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
-      exit 1
+      bailout 1
     fi
 
     if [ -n "$MKFS" ] ; then
        einfo "Running $MKFS on $TARGET"
-       $MKFS $TARGET
-       TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
-       eend $?
+       $MKFS $TARGET ; RC=$?
+
+       # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
+       # will fail to detect the uuid in the chroot
+       if echo "$TARGET" | grep -q "/dev/md" ; then
+         blockdev --rereadpt "${TARGET}"
+       elif ! [ -n "$VIRTUAL" ] ; then
+         blockdev --rereadpt "${TARGET%%[0-9]*}"
+       fi
+       # give the system 2 seconds, otherwise we might run into
+       # race conditions :-/
+       sleep 2
+
+       eval $(blkid -o udev $TARGET 2>/dev/null)
+       [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
+
+       eend $RC
     fi
 
   fi
@@ -742,7 +896,7 @@ mkfs() {
 
 # modify filesystem settings {{{
 tunefs() {
-  if [ -n "$TUNE2FS" ] ; then
+  if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
      $TUNE2FS $TARGET
      eend $?
@@ -758,8 +912,11 @@ mount_target() {
      if grep -q $TARGET /proc/mounts ; then
         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
      else
-       [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
+       if ! [ -d "${MNTPOINT}" ] ; then
+          [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
+       fi
        einfo "Mounting $TARGET to $MNTPOINT"
+       mkdir -p "$MNTPOINT"
        mount -o rw,suid,dev $TARGET $MNTPOINT
        eend $?
      fi
@@ -773,6 +930,109 @@ mount_target() {
 }
 # }}}
 
+# prepare VM image for usage with debootstrap {{{
+prepare_vm() {
+  if [ -z "$VIRTUAL" ] ; then
+     return 0 # be quite by intention
+  fi
+
+  if [ -b "$TARGET" ] ; then
+     eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
+     eend 1
+     bailout 1
+  fi
+
+  ORIG_TARGET="$TARGET" # store for later reuse
+
+  qemu-img create -f raw "${TARGET}" "${VMSIZE}"
+  echo 4 66 | /usr/share/grml-debootstrap/bootgrub.mksh -A | dd of="$TARGET" conv=notrunc
+  dd if=/dev/zero bs=1 conv=notrunc count=64 seek=446 of="$TARGET"
+  parted -s "${TARGET}" 'mkpart primary ext3 2M -1'
+
+  # if dm-mod isn't available then kpartx will fail with
+  # "Is device-mapper driver missing from kernel? [...]"
+  if ! kpartx -av $TARGET >/dev/null 2>&1 || ! grep -q device-mapper /proc/misc >/dev/null 2>&1 ; then
+    einfo "Device-mapper not ready yet, trying to load dm-mod module."
+    modprobe dm-mod ; eend $?
+  fi
+
+  # make sure loop module is present
+  if ! losetup -f >/dev/null 2>&1; then
+    einfo "Can not find a usable loop device, retrying after loading loop module."
+    modprobe loop
+    if losetup -f >/dev/null 2>&1; then
+      einfo "Found a usable loop device now, continuing."
+    else
+      eerror "Error finding usable loop device" ; eend 1
+      bailout 1
+    fi
+  fi
+
+  DEVINFO=$(kpartx -av $TARGET) # 'add map loop1p1 (253:0): 0 6289408 linear /dev/loop1 2048'
+  if [ -z "${DEVINFO}" ] ; then
+    eerror "Error setting up loopback device." ; eend 1
+    bailout 1
+  fi
+
+  # hopefully this always works as expected
+  LOOP=$(echo ${DEVINFO} | sed 's/.* linear //; s/ [[:digit:]]*//') # '/dev/loop1'
+  BLOCKDEV=$(echo "${DEVINFO}" | sed -e 's/.* (\(.*:.*\)).*/\1/')   # '253:0'
+  LOOP_PART="$(echo ${DEVINFO##add map } | sed 's/ .*//')" # '/dev/loop1p1'
+  export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
+
+  blockdev --rereadpt "${LOOP}"
+
+  if [ -z "$TARGET" ] ; then
+     eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
+     bailout 1
+  fi
+}
+# }}}
+
+# make VM image bootable and unmount it {{{
+finalize_vm() {
+  if [ -z "${VIRTUAL}" ] ; then
+     return 0
+  fi
+
+  if ! mount "${TARGET}" "${MNTPOINT}" ; then
+    eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
+    bailout 1
+  fi
+
+  einfo "Installing Grub as bootloader."
+  mount -t proc none "${MNTPOINT}"/proc
+  mount -t sysfs none "${MNTPOINT}"/sys
+  mount --bind /dev "${MNTPOINT}"/dev
+
+  mkdir -p "${MNTPOINT}/boot/grub"
+  if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
+     eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
+     bailout 1
+  fi
+
+  cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
+  chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
+  dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=4
+  rm -f "${MNTPOINT}/tmp/core.img"
+
+  einfo "Updating grub configuration file."
+  chroot "${MNTPOINT}" update-grub
+
+  umount "${MNTPOINT}"/proc
+  umount "${MNTPOINT}"/sys
+  umount "${MNTPOINT}"/dev
+
+  einfo "Adjusting grub.cfg for successful boot sequence."
+  # ugly but needed to boot grub acordingly
+  sed -i "s;set root=.*;set root='(hd0,msdos1)';" "${MNTPOINT}"/boot/grub/grub.cfg
+  sed -i "s;root=[^ ]\+;root=/dev/sda1;" "${MNTPOINT}"/boot/grub/grub.cfg
+
+  umount "${MNTPOINT}"
+  kpartx -d "${ORIG_TARGET}" >/dev/null
+}
+# }}}
+
 # install main chroot {{{
 debootstrap_system() {
   if [ "$_opt_nodebootstrap" ]; then
@@ -781,17 +1041,34 @@ debootstrap_system() {
   fi
 
   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
-     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     if [ -n "$MIRROR" ] ; then
-        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
-     else
-        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
-     fi
-     eend $?
+    :
   else
-     eerror "Error: $MNTPOINT not mounted, can not continue."
-     eend 1
+    eerror "Error: $MNTPOINT not mounted, can not continue."
+    eend 1 ; exit 1
+  fi
+
+  if [ -n "$ISO" ] ; then
+    einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
+    $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+    RC=$?
+  else
+    einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
+    $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
+    RC=$?
   fi
+
+  if [ $RC -ne 0 ] ; then
+    if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
+      [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
+      einfo "Presenting last ten lines of debootstrap.log:"
+      tail -10 $MNTPOINT/debootstrap/debootstrap.log
+      einfo "End of debootstrap.log"
+    fi
+  fi
+
+  eend $RC
 }
 # }}}
 
@@ -804,18 +1081,41 @@ preparechroot() {
   touch $CHROOT_VARIABLES
   chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
   echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
-  [ -n "$ARCH" ]         && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
-  [ -n "$GROOT" ]        && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
-  [ -n "$GRUB" ]         && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
-  [ -n "$HOSTNAME" ]     && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
-  [ -n "$ISODIR" ]       && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
-  [ -n "$ISO" ]          && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]       && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
-  [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
-  [ -n "$PACKAGES" ]     && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
-  [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-  [ -n "$TARGET" ]       && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
-  [ -n "$TARGET_UUID" ]  && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+  [ -n "$ARCH" ]                && echo "ARCH=\"$ARCH\""                               >> $CHROOT_VARIABLES
+  [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS=\"$CHROOT_SCRIPTS\""           >> $CHROOT_VARIABLES
+  [ -n "$CONFFILES" ]           && echo "CONFFILES=\"$CONFFILES\""                     >> $CHROOT_VARIABLES
+  [ -n "$DEBCONF" ]             && echo "DEBCONF=\"$DEBCONF\""                         >> $CHROOT_VARIABLES
+  [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND=\"$DEBIAN_FRONTEND\""         >> $CHROOT_VARIABLES
+  [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP=\"$DEBOOTSTRAP\""                 >> $CHROOT_VARIABLES
+  [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES=\"$EXTRAPACKAGES\""             >> $CHROOT_VARIABLES
+  [ -n "$FORCE" ]               && echo "FORCE=\"$FORCE\""                             >> $CHROOT_VARIABLES
+  [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS=\"$GRMLREPOS\""                     >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]                && echo "GRUB=\"$GRUB\""                               >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]            && echo "HOSTNAME=\"$HOSTNAME\""                       >> $CHROOT_VARIABLES
+  [ -n "$INITRD" ]              && echo "INITRD=\"$INITRD\""                           >> $CHROOT_VARIABLES
+  [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES=\"$INSTALL_NOTES\""             >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]              && echo "ISODIR=\"$ISO\""                              >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]                 && echo "ISO=\"$ISO\""                                 >> $CHROOT_VARIABLES
+  [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST=\"$KEEP_SRC_LIST\""             >> $CHROOT_VARIABLES
+  [ -n "$LOCALES" ]             && echo "LOCALES=\"$LOCALES\""                         >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]              && echo "MIRROR=\"$MIRROR\""                           >> $CHROOT_VARIABLES
+  [ -n "$MKFS" ]                && echo "MKFS=\"$MKFS\""                               >> $CHROOT_VARIABLES
+  [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                          >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]            && echo "PACKAGES=\"$PACKAGES\""                       >> $CHROOT_VARIABLES
+  [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS=\"$PRE_SCRIPTS\""                 >> $CHROOT_VARIABLES
+  [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE=\"$RECONFIGURE\""                 >> $CHROOT_VARIABLES
+  [ -n "$RELEASE" ]             && echo "RELEASE=\"$RELEASE\""                         >> $CHROOT_VARIABLES
+  [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE=\"$RM_APTCACHE\""                 >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD=\"$ROOTPASSWORD\""               >> $CHROOT_VARIABLES
+  [ -n "$SCRIPTS" ]             && echo "SCRIPTS=\"$SCRIPTS\""                         >> $CHROOT_VARIABLES
+  [ -n "$SECURE" ]              && echo "SECURE=\"$SECURE\""                           >> $CHROOT_VARIABLES
+  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=\"$SELECTED_PARTITIONS\"" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]              && echo "TARGET=\"$TARGET\""                           >> $CHROOT_VARIABLES
+  [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM=\"$UPGRADE_SYSTEM\""           >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID=\"$TARGET_UUID\""                 >> $CHROOT_VARIABLES
+  [ -n "$TIMEZONE" ]            && echo "TIMEZONE=\"$TIMEZONE\""                       >> $CHROOT_VARIABLES
+  [ -n "$TUNE2FS" ]             && echo "TUNE2FS=\"$TUNE2FS\""                         >> $CHROOT_VARIABLES
+  [ -n "$VMSIZE" ]              && echo "VMSIZE=\"$VMSIZE\""                           >> $CHROOT_VARIABLES
 
   cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
@@ -827,7 +1127,11 @@ preparechroot() {
   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
-  sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
+
+  # install notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" $MNTPOINT/etc/debootstrap/
+  fi
 
   # package selection:
   cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
@@ -879,10 +1183,31 @@ preparechroot() {
      cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
   fi
 
+  # install config file providing some example entries
+  if [ -r /etc/network/interfaces.examples -a ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
+     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
+  fi
+
   eend 0
 }
 # }}}
 
+# execute all scripts in /etc/debootstrap/pre-scripts/ {{{
+execute_pre_scripts() {
+   # make sure we have $MNTPOINT available for our scripts
+   export MNTPOINT
+   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
+      [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="$CONFFILES/pre-scripts/"
+      for script in ${pre_scripts}/* ; do
+         if [ -x "$script" ] ; then
+            einfo "Executing pre-script $script"
+            $script ; eend $?
+         fi
+      done
+   fi
+}
+# }}}
+
 # execute all scripts in /etc/debootstrap/scripts/ {{{
 execute_scripts() {
    # make sure we have $MNTPOINT available for our scripts
@@ -902,46 +1227,41 @@ execute_scripts() {
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
-     mount_target
+    mount_target
   fi
-  if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
-     einfo "Executing chroot-script now"
-     chroot "$MNTPOINT" /bin/chroot-script
-     eend $?
+
+  if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
+    eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
+    eend 1
   else
-     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
-     eend 1
+    einfo "Executing chroot-script now"
+    mount --bind /dev "$MNTPOINT"/dev
+    chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
+    umount "$MNTPOINT"/dev
+    eend $RC
   fi
-}
-# }}}
 
-# install booloader grub {{{
-grub_install() {
-  if [ -z "$GRUB" -o -z "$GROOT" ] ; then
-     echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
-  elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
-     for device in $SELECTED_PARTITIONS ; do
-        # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
-        # GRUB="$(grubdevice ${TMPDEVICE})"
-        # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
-        # GRUB=$(grubdevice $device)
-        GRUB="$(grubdevice ${device%%[0-9]})"
-        einfo "Installing grub on ${GRUB}:"
-        [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-        $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
-        eend $?
-     done
+  # finally get rid of chroot-script again, there's no good reason to
+  # keep it on the installed system
+  if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
+    einfo "Removing chroot-script again"
+    rm -f "${MNTPOINT}/bin/chroot-script"
+    eend $?
   else
-     einfo "Installing grub on ${GRUB}:"
-     [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-     $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
-     eend $?
+    einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
+    eend 0
   fi
 }
 # }}}
 
-# unmount $MNTPOINRT {{{
+# unmount $MNTPOINT {{{
 umount_chroot() {
+
+  # display installation notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
+  fi
+
   if [ -n "$ISODIR" ] ; then
      if grep -q "$ISODIR" /proc/mounts ; then
         einfo "Unmount $MNTPOINT/$ISODIR"
@@ -962,43 +1282,44 @@ umount_chroot() {
 
 # execute filesystem check {{{
 fscktool() {
-  if [ "$FSCK" = 'yes' ] ; then
-     [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
-     einfo "Checking filesystem on $TARGET using $FSCKTOOL"
-     $FSCKTOOL $TARGET
-     eend $?
-  fi
+ if [ -n "$VIRTUAL" ] ; then
+   einfo "Skipping filesystem check because we deploy a virtual machine."
+   return 0
+ fi
+
+ if [ "$FSCK" = 'yes' ] ; then
+   [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
+   einfo "Checking filesystem on $TARGET using $FSCKTOOL"
+   $FSCKTOOL $TARGET
+   eend $?
+ fi
 }
 # }}}
 
 # now execute all the functions {{{
-for i in mkfs tunefs mount_target debootstrap_system preparechroot \
-         chrootscript execute_scripts grub_install umount_chroot   \
-         fscktool ; do
+for i in prepare_vm mkfs tunefs mount_target debootstrap_system \
+         preparechroot execute_pre_scripts chrootscript execute_scripts \
+         umount_chroot finalize_vm fscktool ; do
     if stage "${i}" ; then
-       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
+       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "$i"
     fi
 done
-# }}}
-
-# finalize {{{
-einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
-einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
 
-# Remove temporary mountpoint again
-if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-   einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
-fi
+cleanup
 # }}}
 
 # end dialog of autoinstallation {{{
 if [ -n "$AUTOINSTALL" ] ; then
-   dialog --title "$PN" --msgbox \
-          "Finished execution of ${PN}. Enjoy your Debian system." 0 0
+   if dialog --title "${PN}" --pause "Finished execution of ${PN}.
+Automatically rebooting in 10 seconds.
+
+Choose Cancel to skip rebooting." 10 60 10 ; then
+     noeject noprompt reboot
+  fi
 else
    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
 fi
 # }}}
 
 ## END OF FILE #################################################################
-# vim: ai tw=100 expandtab foldmethod=marker shiftwidth=3
+# vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2